summaryrefslogtreecommitdiffstats
path: root/system/qemu/qemu.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'system/qemu/qemu.SlackBuild')
-rw-r--r--system/qemu/qemu.SlackBuild87
1 files changed, 37 insertions, 50 deletions
diff --git a/system/qemu/qemu.SlackBuild b/system/qemu/qemu.SlackBuild
index 57a43b834a..1f6ebfffbb 100644
--- a/system/qemu/qemu.SlackBuild
+++ b/system/qemu/qemu.SlackBuild
@@ -1,9 +1,9 @@
-#!/bin/sh
+#!/bin/bash
# Slackware build script for qemu
# Copyright 2009, 2010 Andrew Brouwers <abrouwers@gmail.com>
-# Copyright 2013-2018 Edward Koenig, Vancouver, USA <kingbeowulf@gmail.com>
+# Copyright 2013-2024 Edward W. Koenig, Vancouver, USA <kingbeowulf@linuxgalaxy.org>
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -23,51 +23,20 @@
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-# Changelog
-# 1.0 27-FEB-2013 New SBo maintainer
-# 1.0 07-MAR-2013 updated to 1.4, includes qemu-kvm; thanks to
-# rworkman and ponce for script ideas.
-# 1.1 28-MAR-2013 fix missing docs per C. Willing and
-# add missing --libdir (patched in qemu-trivial upstream)
-# 1.2 22-SEP-2013 updated to 1.6
-# 1.3 03-NOV-2013 updated to 1.6.1
-# 1.4 28-APR-2014 updated to 2.0.0 (thanks Callum Davies <calrogman@gmail.com>), added useful options,
-# clean ups, libusb version check.
-# 1.4a 04-MAY-2014 fixed typos thanks to sandb0y
-# 1.5 10-AUG-2014 updated to new version, watch for legacy "gotchas"
-# 1.6 18-NOV-2014 updated version, last of the 2.1 series, changed defaults per SBo list
-# 1.6a 23-NOV-2014 added overlooked AUDIODRIVERS switch per SBo list
-# 1.7 01-JAN-2015 updated to 2.2.0 ; build and link static libusb option (rw, tm, SBo list)
-# 1.8 27-APR-2015 updated to version 2.3.0
-# 1.9 14-MAY-2015 patched for "Venom" CVE-2015-3456 http://git.qemu.org/?p=qemu.git;a=commitdiff;h=e907746266721f305d67bc0718795fedee2e824c
-# 2.0 11-JUL-2015 patched for Heap-based buffer overflow in the PCNET controller CVE-2015-3209 http://git.qemu.org/?p=qemu.git;a=commitdiff;h=9f7c594c006289ad41169b854d70f5da6e400a2a
-# 2.1 27-JUL-2015 patched for heap overflow flaw while processing certain ATAPI commands CVE-2015-5154 http://git.qemu.org/?p=qemu.git;a=commitdiff;h=e40db4c6d391419c0039fe274c74df32a6ca1a28;hp=f793d97e454a56d17e404004867985622ca1a63b
-# 3.0 05-SEP-2015 uprgraded to new version
-# 3.1 13-DEC-2015 uprgraded to new version, minor clean ups
-# 3.1 02-SEP-2016 upgraded.
-# 3.2 15-OCT-2016 upgraded to 2.7 release
-# 3.3 26-JAN-2017 upgraded to 2.8 release
-# 4.0 28-JAN-2017 add bridge-helper option, README additions/cosmetics (thanks to Andrzej T.)
-# 4.1 01-APR-2017 no foolin': various bug and CVE updates re: ponce https://lists.nongnu.org/archive/html/qemu-devel/2017-03/msg06332.html
-# 4.2 05-JUN-2017 version update to 2.9 release
-# 4.3 06-JAN-2018 version update to 2.10.x release
-# 4.4 17-Feb-2018 version update to 2.11.x release, Spectre/Meltdown mitigation
-# 4.5 03-Jun-2018 version update to 2.12.0 release, note new deps: sdl2, gtk+3
-# 5.0 14-Dec-2018 version update to 3.1.0 release, note minimum dependency versions on release notes
-# 6.0 14-JUL-2019 version update to 4.0.0 release, note minimum dependency versions on release notes, doc fixes
-# 6.1 19-AUG-2019 version update
-# 6.2 16-Nov-2020 version update, 14.2 final release.
+cd $(dirname $0) ; CWD=$(pwd)
PRGNAM=qemu
-VERSION=${VERSION:-4.1.1}
-BUILD=${BUILD:-1}
+VERSION=${VERSION:-8.2.2}
+BUILD=${BUILD:-2}
TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
KVMGROUP=${KVMGROUP:-users}
-TARGETS=${TARGETS:-some}
+TARGETS=${TARGETS:-all}
VNC_ENABLE=${VNC_ENABLE:-yes}
AUDIODRIVERS=${AUDIODRIVERS:-pa,alsa,oss,sdl}
BRIDGE_HELPER_SETUID=${BRIDGE_HELPER_SETUID:-no}
+SLIRP=${SLIRP:-=no}
if [ -z "$ARCH" ]; then
case "$( uname -m )" in
@@ -77,7 +46,11 @@ if [ -z "$ARCH" ]; then
esac
fi
-CWD=$(pwd)
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
@@ -102,6 +75,9 @@ fi
# Needed to build man pages if built after plain "su"
export PATH=$PATH:/usr/share/texmf/bin
+# Autodetect liburing support
+uring="dis" ; if pkg-config --exists liburing ; then uring="en" ; fi
+
set -e
rm -rf $PKG
@@ -113,10 +89,14 @@ cd $PRGNAM-$VERSION
chown -R root:root .
find -L . \
\( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
- -o -perm 511 \) -exec chmod 755 {} \; -o \
+ -o -perm 511 \) -exec chmod 755 {} + -o \
\( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
- -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} + || true
+# Use newer meson from python3-meson-opt
+PYVER=$(python3 -c 'import sys; print("%d.%d" % sys.version_info[:2])')
+export PYTHONPATH=/opt/python$PYVER/site-packages
+
# Remove double CFLAGS
sed -i "s|^\ \ CFLAGS=\"-O2\ | CFLAGS=\"|" configure
@@ -125,7 +105,7 @@ sed -i "s|^\ \ CFLAGS=\"-O2\ | CFLAGS=\"|" configure
if [ "$TARGETS" = "all" ]; then
targets=""
else
- targets="--target-list=i386-softmmu,x86_64-softmmu,i386-linux-user,x86_64-linux-user,arm-softmmu,arm-linux-user,armeb-linux-user"
+ targets="--target-list=$TARGETS"
fi
# To omit VNC capability, use VNC_ENABLE=no
@@ -135,6 +115,13 @@ else
with_vnc="--disable-vnc"
fi
+# To enable user mode networking use SLIRP=yes
+if [ "$SLIRP" = "yes" ]; then
+ with_slirp="--enable-slirp"
+else
+ with_slirp=""
+fi
+
CFLAGS="$SLKCFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
./configure \
@@ -149,20 +136,19 @@ CXXFLAGS="$SLKCFLAGS" \
--disable-debug-info \
--enable-virtfs \
--enable-sdl \
- --enable-jemalloc \
+ --enable-malloc=jemalloc \
--enable-nettle \
+ --${uring}able-linux-io-uring \
--audio-drv-list=${AUDIODRIVERS} \
+ $with_slirp \
$with_vnc \
$targets
-# Make these first; otherwise make won't run in parallel.
-make config-all-devices.mak config-all-disas.mak
-
make V=1
make install DESTDIR=$PKG
# Remove empty /var
-rm -rf $PKG/var/run
+rm -rf $PKG/var
# install some udev rules for /dev/kvm
# Note: no udev rules for usb pasthrough when running qemu as non-root on linux hosts. See Section 2.11.2
@@ -191,12 +177,13 @@ fi
# Add docs to the proper location
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a Changelog COPYING* CODING_STYLE HACKING LICENSE MAINTAINERS README docs/* \
+cp -a COPYING* LICENSE MAINTAINERS README.rst docs/* \
$PKG/usr/doc/$PRGNAM-$VERSION
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
cd $PKG
-/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE